UNIT Fonts;
INTERFACE
USES WinTypes;

FUNCTION ChangeFont(hWindow:hWnd):Bool;
FUNCTION GetINIFont(aFile,aSection:pChar):pLogFont;
PROCEDURE WriteINIFont(aFile,aSection:pChar);
FUNCTION GetIniColor(aFile,aSection,aKey:pChar;DefColor:tColorRef):Longint;
PROCEDURE WriteIniColor(aFile,aSection,aKey:pChar;Color:tColorRef);

IMPLEMENTATION
USES WinProcs,CommDlg;

CONST DefaultFont:tLogFont=(
    lfheight:-8;
    lfwidth:0;
    lfescapement:0;
    lforientation:0;
    lfweight:400;
    lfitalic:0;
    lfunderline:0;
    lfstrikeout:0;
    lfcharset:255;
    lfoutprecision:1;
    lfclipprecision:2;
    lfquality:1;
    lfpitchandfamily:49;
    lffacename:'Terminal');
VAR lFont:tLogFont;

FUNCTION GetIniColor(aFile,aSection,aKey:pChar;DefColor:tColorRef):Longint;
VAR s,s1:STRING[12];
    i:Longint;
    j:Integer;
BEGIN
  Str(DefColor,s1);s1[Length(s1)+1]:=#0;
  Byte(s[0]):=GetPrivateProfileString(aSection,aKey,@s1[1],@s[1],12,aFile);
  Val(s,i,j);
  IF j=0 THEN GetIniColor:=i ELSE GetIniColor:=DefColor;
END;

PROCEDURE WriteIniColor(aFile,aSection,aKey:pChar;Color:tColorRef);
VAR pc:ARRAY[0..12]OF Char;
BEGIN
  Str(Color,pc);
  WritePrivateProfileString(aSection,aKey,pc,aFile);
END;

FUNCTION GetINIFont(aFile,aSection:pChar):pLogFont;
BEGIN
  WITH DefaultFont DO
  BEGIN
    lFont.lfHeight:=GetPrivateProfileInt(aSection,'fontHeight',lfHeight,aFile);
    lFont.lfwidth:=GetPrivateProfileInt(aSection,'fontWidth',lfWidth,aFile);
    lFont.lfescapement:=GetPrivateProfileInt(aSection,'fontEscapeMent',lfEscapeMent,aFile);
    lFont.lforientation:=GetPrivateProfileInt(aSection,'fontOrientation',lfOrientation,aFile);
    lFont.lfweight:=GetPrivateProfileInt(aSection,'fontWeight',lfWeight,aFile);
    lFont.lfitalic:=GetPrivateProfileInt(aSection,'fontItalic',lfItalic,aFile);
    lFont.lfunderline:=GetPrivateProfileInt(aSection,'fontUnderline',lfunderline,aFile);
    lFont.lfstrikeout:=GetPrivateProfileInt(aSection,'fontStrikeOut',lfStrikeOut,aFile);
    lFont.lfcharset:=GetPrivateProfileInt(aSection,'fontCharSet',lfCharSet,aFile);
    lFont.lfoutprecision:=GetPrivateProfileInt(aSection,'fontOutPrecision',lfOutPrecision,aFile);
    lFont.lfclipprecision:=GetPrivateProfileInt(aSection,'fontClipPrecision',lfClipPrecision,aFile);
    lFont.lfquality:=GetPrivateProfileInt(aSection,'fontQuality',lfQuality,aFile);
    lFont.lfpitchandfamily:=GetPrivateProfileInt(aSection,'fontPitchAndFamily',lfPitchAndFamily,aFile);
    GetPrivateProfileString(aSection,'fontName',@lffacename,@lFont.lfFaceName,SizeOf(lfFaceName),aFile);
  END;
  GetINIFont:=@lFont;
END;

PROCEDURE WriteINIFont(aFile,aSection:pChar);
  PROCEDURE WritePrivateProfileInt(aSection,aKey:pChar;aValue:Integer;aFile:pChar);
  VAR What:ARRAY[0..10]OF Char;
  BEGIN
    Str(aValue,What);
    WritePrivateProfileString(aSection,aKey,What,aFile);
  END;
BEGIN
  WITH lFont DO
  BEGIN
    WritePrivateProfileInt(aSection,'fontHeight',lfHeight,aFile);
    WritePrivateProfileInt(aSection,'fontWidth',lfWidth,aFile);
    WritePrivateProfileInt(aSection,'fontEscapeMent',lfEscapeMent,aFile);
    WritePrivateProfileInt(aSection,'fontOrientation',lfOrientation,aFile);
    WritePrivateProfileInt(aSection,'fontWeight',lfWeight,aFile);
    WritePrivateProfileInt(aSection,'fontItalic',lfItalic,aFile);
    WritePrivateProfileInt(aSection,'fontUnderline',lfunderline,aFile);
    WritePrivateProfileInt(aSection,'fontStrikeOut',lfStrikeOut,aFile);
    WritePrivateProfileInt(aSection,'fontCharSet',lfCharSet,aFile);
    WritePrivateProfileInt(aSection,'fontOutPrecision',lfOutPrecision,aFile);
    WritePrivateProfileInt(aSection,'fontClipPrecision',lfClipPrecision,aFile);
    WritePrivateProfileInt(aSection,'fontQuality',lfQuality,aFile);
    WritePrivateProfileInt(aSection,'fontPitchAndFamily',lfPitchAndFamily,aFile);
    WritePrivateProfileString(aSection,'fontName',@lfFaceName,aFile);
  END;
END;

FUNCTION ChangeFont(hWindow:hWnd):Bool;
VAR Font      :tChooseFont;
    NewFont   :hFont;
    fx        :ttextmetric;
BEGIN
  ChangeFont:=False;
  FillChar(FONT,SizeOf(FONT),0);
  Font.hInstance:=hInstance;
  WITH Font DO
  BEGIN
    lStructSize:=SizeOf(FONT);
    hWndOwner:=hWindow;
    hDC:=0;
    lpLogFont:=@lFONT;
    Flags:=CF_FORCEFONTEXIST OR CF_NOSIMULATIONS OR CF_SCREENFONTS OR CF_LimitSize
           OR CF_INITTOLOGFONTSTRUCT OR CF_FixedPitchOnly OR CF_EnableTemplate;
    nSizeMin:=4;
    nSizeMax:=80;
    RgbColors:=0;
    lpTemplateName:='CHOOSEFONT';
  END;
  ChangeFont:=ChooseFont(Font);
END;

BEGIN
END.